%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Tensor completion for esimtating missing values in visual data, PAMI,
% example.m file
% Date Mar. 13, 2012
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;
close all;
addpath('H:\TensorCompletion\mylib/');
load('H:\dc.mat');
A=ones(200,200,60);
D=ones(200,200,60);
for m=1:60
A(:,:,m)=R(:,:,m);
D(:,:,m)=R(:,:,m);
end
B=ones(200,200);
totalNum=40000;%ɾóԪܸ
randomIndex=1+floor(rand(1,floor(totalNum*0.7))*totalNum);%ֵ1ԪظtotalNum֮totalNum*20%ΪнҪԪص±(ʱѾһһά)
C=ones(200,200);
C(randomIndex)=0;
for m=1:60
B=A(:,:,m);
max_B=max(max(B));  % ֵ
min_B=min(min(B));   % Сֵ
B=double(255.*((B-min_B)/(max_B-min_B))); % һ
B(randomIndex)=255;%ɵ
A(:,:,m)=B;
D(:,:,m)=C;
end
T=A;
Omega =(D==1);
alpha = [1, 1, 1e-3];
alpha = alpha / sum(alpha);

maxIter = 500;
epsilon = 1e-6;
% "X" returns the estimation, 
% "errList" returns the list of the relative difference of outputs of two neighbor iterations 

%% High Accuracy LRTC (solve the original problem, HaLRTC algorithm in the paper)
rho = 1e-6;
[X_H, errList_H] = HaLRTC(...
    T, ...                       % a tensor whose elements in Omega are used for estimating missing value
    Omega,...               % the index set indicating the obeserved elements
    alpha,...                  % the coefficient of the objective function, i.e., \|X\|_* := \alpha_i \|X_{i(i)}\|_* 
    rho,...                      % the initial value of the parameter; it should be small enough  
    maxIter,...               % the maximum iterations
    epsilon...                 % the tolerance of the relative difference of outputs of two neighbor iterations 
    );

figure('units','normalized','outerposition',[0 0 1 1]);
% figure;
% set(0, 'DefaultFigurePosition', [0, 0, 2000, 1000]);
subplot(2,2,1);
imshow(T(:,:,30),[]);
title('Original');
subplot(2,2,2);
imshow(1-(Omega(:,:,30)));
title('Missing Values');
subplot(2,2,3);
imshow(X_H(:,:,30),[]);
title('HaLRTC');
%matrix evaluation
E=ones(200,200,60);
ERROR=ones(60,1);
for m=1:60
E(:,:,m)=R(:,:,m);
max_E=max(max(E(:,:,m)));  % ֵ
min_E=min(min(E(:,:,m)));   % Сֵ
E(:,:,m)=double(255.*((E(:,:,m)-min_E)/(max_E-min_E))); % һ
 ERROR(m,:)=norm(X_H(:,:,m)-E(:,:,m))/norm(E(:,:,m));
end
%tensor evaluation
s=0;
for m=1:60
    s=s+(norm(E(:,:,m)))^2;
end
Y=X_H-E(:,:,1:60);
y=0;
for m=1:60
    y=y+(norm(Y(:,:,m)))^2;
end
error=((y)^(0.5))/((s)^(0.5));
sum(ERROR)/60
error




