% Fast Positive Deconvolution of Hyperspectral Images
% Simon Henrot, Charles Soussen, and David Brie
% IEEE Trans. Image Process, vol. 22, no. 2, pp. 828-833, 2013.
%%=====================================================================
clear all; close all; clc;
addpath(genpath('Assesment Index\'));
%% ͼ
pathName = 'images/';  %%ʽһµͼļ
Imgs = dir(strcat([pathName,'*.png'])); %ȡȫtiffͼΪṹ
frameNum = length(Imgs);  %ͼ

%% ģ˴С, Ըı
window = [8 8]; %Ϊ11x11

%% ʼg, ker, sumker
% ker(:,:,frameNum) = zeros(window);
% sumKer = zeros(window);
for i = 1 : frameNum
    fileName = strcat(pathName, Imgs(i).name);
    
    %% ȡͼ񲢹һ
    img = im2double(imread(fileName)); %һdouble, old
%     img = double(imread(fileName)); %double
    %img = (img-min(img(:)))/(max(img(:))-min(img(:))); %һ
    [r, c] = size(img);
    utrue(:,:,i) = img;
    
    %%% ɷ gaussian ģ
    sigma = 3 + 0.00*i;
    ker(:,:,i) = fspecial('gaussian',window,sigma);
    
    %% ȼ
    lev = 0;
    noiseLevel = lev*1.e-3;
    
    %%% ̶
    rand('state',1000);rand('seed',1000);
    randn('state',1000); randn('seed',1000);
    
    %%% õ degraded ͼ
    g(:,:,i) = conv2c(img,ker(:,:,i)) + noiseLevel*randn(size(img));
    
    %%% ˻ͼӱ wrap bound߽չ
    gwrap(:,:,i) = wrap_boundary_liu( g(:,:,i), opt_fft_size( [r c] + size(ker(:,:,i))-1 ));
    
    %%% һ
    gwrap(:,:,i) = Normalize(gwrap(:,:,i));   
end

%% 
conv = 'circular'; % circular and direct
regu = 'l2'; %ռ
pos = 'on'; %Լ, 'off'ΪʩԼ

%% 
mu = 0.0001;
nu = 0.75;

mu = 0.001;
nu = 0.075;
%% Final deconvolution with the estimated regu parameters
tic
xwrap = deconvs_auto(gwrap, ker, mu, nu, conv, regu, pos);
x = xwrap(1:r,1:c,:); %ԭʼС
toc
%% 洢ļ
dirFlag = 0;
savefile = ['result(' fileName(8:end-4) ',psf' num2str(window(1)) ',' num2str(mu) ',' num2str(nu) ',frames' num2str(frameNum) ')' ''];
if exist(savefile,'dir')
    dirFlag = 1;
end
if (dirFlag == 0)
    mkdir(savefile);
end
pathResult = savefile;

%% ״Ľ
for i = 1 : size(x,3)
    imwrite(x(:,:,i)/max(x(:)),[pathResult '/' 'band' num2str(i) '.png']);
end


