close all; clear all; clc;
addpath(genpath('Assesment Index\'));
%% ================== Simulate Experiment ================
experiType = 'simulate';

pathName = './images/';
disp('-------------------------------------------------------');
disp('Please choose one of the defaults!');
disp('-------------------------------------------------------');
disp('1) aviris band30_cut[250x250]');
choice = input('Input your choice:');
while choice~=1
    disp('Error! Please choose again!');
    choice = input('Input your choice:');
end
switch choice
    case 1
        fileName = 'face_ms_';
        % -------------- get simulate images of different bands -----------
        % ֡
        frameNum = 31;
        % ģ˴С
        window = [8 8];
        % ʼgkersumker
        ker(:,:,frameNum) = zeros(window);
        sumKer = zeros(window);
        i = 1;
        while i<=frameNum
            % --------------------- get the clean image -------------------
            % ȡͼ
            img = double(imread([pathName fileName num2str(i) '.png']));%  עi+4ʵȥͼƬband35~3931~35
            % һ
            img=(img-min(img(:)))/(max(img(:))-min(img(:)));
            [r c] = size(img);
            % wrap bound߽չ
            img = wrap_boundary_liu( img, opt_fft_size( [r c] + size(ker(:,:,i))-1 ));
            
            utrue(:,:,i) = img;
            %  gaussianģ
            sigma = 3 + 0.00000*i;
            ker(:,:,i) = fspecial('gaussian',window,sigma);
            % ȼ
            lev = 0;
            noiseLevel = lev*1.e-5;
            % ̶
            rand('state',1000);rand('seed',1000);
            randn('state',1000); randn('seed',1000);
            % õdegradedͼ
            g(:,:,i) = imfilter(img,ker(:,:,i),'circular','conv') + noiseLevel*randn(size(img));
            % ۼkernel
            sumKer = sumKer+ker(:,:,i);
            i = i+1;
        end
        % get the PSFsystem witch is the linear combination of PSFs
        % here we just reguard PSFsystem or H as the mean of PSFs
        H =  sumKer/frameNum;
        
       %%   params setting  -------------------------------------
        params.iniAlpha = 0.0001;
        params.iniBeta = 0.01;
        params.iniSigma = 1.5;
        
        params.alpha = params.iniAlpha;
        params.beta = params.iniBeta;
        params.sigma = params.iniSigma;
        
%         params.mu = [1 1 1.5];
        params.mu = [1 1 1];
        %params.gamma = 2;
        %params.alpha1 = 0.7;

        params.showFrame = 7;
        params.fvTol = 1e-5;
        params.maxIter = 50;
end


%% show degraded
scrSize = get(0,'ScreenSize');
position = [scrSize(3)/4 scrSize(4)/8 scrSize(3)/2 scrSize(4)*3/4];
figure('Position',position);
params.showFrame = 20;
figure(1),subplot(241),imshow(g(:,:,params.showFrame));
psnr_1 = psnr(utrue(:,:,params.showFrame),g(:,:,params.showFrame));
title(sprintf('Degraded PSNR:%.4f',psnr_1),'fontsize',14,'fontname','Times New Roman');
axis off;


%% Main process
tic
[f out params] = HSD_SSTV(utrue,g,H,params);
t = toc;

params.exhaustedTime = t;
params.finalMPSNR = out.PSNR(end);
params.finalMSSIM = out.SSIM(end);
params.finalFunctionValue = out.FunctionValue(end);
% cut the expand boundareis
utrue = utrue(1:r,1:c,:);
g = g(1:r,1:c,:);
f = f(1:r,1:c,:);

% %% show results
% % scrSize = get(0,'ScreenSize');
% % position = [1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2];
% % figure('Position',position);
% figure('Name','Comparison of before and after restoration','NumberTitle','off','Position',get(0,'ScreenSize'));
% frame = size(g,3);
% % show the degraded and restored images
% for i=1:frame
%     psnr_obs = psnr(utrue(:,:,i),g(:,:,i));
%     psnr_res = psnr(utrue(:,:,i),f(:,:,i));
%     figure(2),subplot(3,frame,i),imshow(utrue(:,:,i));title(sprintf('origin %d ',i),'fontsize',14,'fontname','Times New Roman');axis off;
%     figure(2),subplot(3,frame,i+frame),imshow(g(:,:,i));title(sprintf('blurred %d  PSNR:%.4f',i,psnr_obs),'fontsize',14,'fontname','Times New Roman');axis off;
%     figure(2),subplot(3,frame,i+2*frame),imshow(f(:,:,i)); title(sprintf('restored %d  PSNR:%.4f',i,psnr_res),'fontsize',14,'fontname','Times New Roman');axis off;
% end
% 
% %% ʾ MPSNR and FunctionValue 
% figure(100); axis square;axis tight;
% D1 = out.FunctionValue;  % Y
% D2 = out.PSNR;  % YҲ
% S  = 1:length(out.FunctionValue);  % ϲX
% T  = 1:length(out.PSNR);  % ²X
%  
% xlabels{1} = 'Iterations';  % ²Xݱע
% xlabels{2} = ' ';  % ϲXݱע
% ylabels{1} = 'Objective function';  % Yݱע
% ylabels{2} = 'MPSNR(dB)';  % ҲYݱע
% [AY,H1,H2] = plotyy(T,D1,S,D2,'plot'); % ˫X
% 
%   
% 
% legend1 = legend([H1,H2],'Objective function','MPSNR(dB)');% 4'Location','SouthEast'
% set(legend1,'TextColor',[.3,.2,.1],'fontsize',13,'fontname','Times New Roman','FontWeight','bold','Location','East');
% % AY(1),AY(2)ֱΪYľ 
% % Use the line handles to set the LineStyle properties of the left- and right-side plots:
% set(H1,'LineStyle','-','linewidth',2,'color','r');
% set(H2,'LineStyle','--','linewidth',2,'color','b');
%  
% % yҶ˵Ŀ̶ֵСɫ
% set(AY(1),'fontsize',18,'ycolor','black'); % y˿̶ֵɫ
% set(AY(2),'fontsize',18,'ycolor','black'); % yҶ˿̶ֵɫ
%  
% % x̶ֵóɲͬɫ
% set(AY(1),'xcolor','black','fontsize',18)  % x¶˿̶ֵɫ
% set(AY(2),'xcolor','black','fontsize',18)  % x϶˿̶ֵɫ
%  
% % With the axes handles you can specify the YLabel properties of the left- and right-side y-axis:
% set(get(AY(1),'Ylabel'),'String','Objective function','fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% set(get(AY(2),'Ylabel'),'String','MPSNR(dB)','fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% set(get(AY(1),'Xlabel'),'String',xlabels{1},'fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% 
% % ᷶Χ
% set(AY(1),'ylim',[520,980]); % x᷶Χ
% set(AY(2),'ylim',[28.1,28.8]); % y᷶Χ
% set(AY(1),'ytick',520:100:980); % y
% set(AY(2),'ytick',28.1:.2:28.8); % Ҷy, PSNR
% 
% title(' ');
% set(gca,'fontsize',18);
% 
% drawnow
% 
% 
% 
% 
% %% ʾ SSIM and NSDE
% figure(101); axis square;axis tight;
% D1 = out.NSDE;  % Y
% D2 = out.SSIM;  % YҲ
% S  = 1:length(out.NSDE);  % ϲX
% T  = 1:length(out.SSIM);  % ²X
%  
% xlabels{1} = 'Iterations';  % ²Xݱע
% xlabels{2} = ' ';  % ϲXݱע
% ylabels{1} = 'NSDE';  % Yݱע
% ylabels{2} = 'SSIM';  % ҲYݱע
% [AY,H1,H2] = plotyy(T,D1,S,D2,'plot'); % ˫X
% 
%  
% legend1 = legend([H1,H2],'NSDE','SSIM',4);% 4'Location','SouthEast'
% set(legend1,'TextColor',[.3,.2,.1],'fontsize',13,'fontname','Times New Roman','FontWeight','bold');
% % AY(1),AY(2)ֱΪYľ 
% % Use the line handles to set the LineStyle properties of the left- and right-side plots:
% set(H1,'LineStyle','-','linewidth',2,'color','r');
% set(H2,'LineStyle','--','linewidth',2,'color','b');
%  
% % yҶ˵Ŀ̶ֵСɫ
% set(AY(1),'fontsize',18,'ycolor','black'); % y˿̶ֵɫ
% set(AY(2),'fontsize',18,'ycolor','black'); % yҶ˿̶ֵɫ
%  
% % x̶ֵóɲͬɫ
% set(AY(1),'xcolor','black','fontsize',18)  % x¶˿̶ֵɫ
% set(AY(2),'xcolor','black','fontsize',18)  % x϶˿̶ֵɫ
%  
% % With the axes handles you can specify the YLabel properties of the left- and right-side y-axis:
% set(get(AY(1),'Ylabel'),'String','NSDE','fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% set(get(AY(2),'Ylabel'),'String','SSIM','fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% set(get(AY(1),'Xlabel'),'String',xlabels{1},'fontsize',20,'fontname','Times New Roman','FontWeight','bold')
% 
% % ᷶Χ
% % set(AY(1),'ylim',[0,280]); % x᷶Χ
% % set(AY(2),'ylim',[24,27]); % y᷶Χ
% % set(AY(1),'ytick',0:0.002:0.016); % y
% % set(AY(2),'ytick',0.7:0.02:0.86); % Ҷy, PSNR
% 
% title(' ');
% set(gca,'fontsize',18);
% 
% drawnow
% 
% 
% 
% 
% 
% %% Save Results
% saveFlag = true;
% if saveFlag
%     [resultPath paramRecordPath] = saveResult(experiType,fileName,noiseLevel,params,g,f,utrue,out);
%     getSpectralSequence(resultPath,g,f,utrue);
%     
%     % PSNR Objective function ˫ʾͼ
%     % һݷֱΪ600epsͼ
%     print(figure(100),[resultPath '/Proposed Objective function and PSNR Curves.eps'],'-depsc2','-r600');
%     % һtiffͼԱʱ鿴
%     saveas(figure(100),[resultPath '/Proposed Objective function and PSNR Curves.tiff']);
%     
%     % NSDE SSIM ˫ʾͼ
%     % һݷֱΪ600epsͼ
%     print(figure(101),[resultPath '/Proposed NSDE and SSIM Curves.eps'],'-depsc2','-r600');
%     % һtiffͼԱʱ鿴
%     saveas(figure(101),[resultPath '/Proposed NSDE and SSIM Curves.tiff']);
% 
% % %     ´ͳbetaMPSNR,MSSIMӰʱõ
% %     % жϸļǷڣdirFlagΪ1
% %     if exist(paramRecordPath,'dir')
% %         dirFlag = 1;
% %     end
% %     % ½ļ
% %     if (dirFlag == 0)
% %         if ~mkdir(paramRecordPath) 
% %             fprintf('create direct failed!!!');
% %             return;% ʧܣ򷵻
% %         end;
% %     end
% %     
% % 
% % 
% %     % --------------------------- '.txt' -------------------------------
% %     %  *.txt; ע⣺dataDirַпո񣬷޷.txt
% %     txtFile = [paramRecordPath  '/beta_PSNR_FunctionValue.txt'];
% %     fid = fopen(txtFile, 'at+');
% %     fprintf( fid,['beta' '=%.8f\n'],params.beta1);
% %     fprintf( fid,['MPSNR' '=%.8f\n'],out.PSNR(length(out.PSNR)));
% %     fprintf( fid,['FunctionValue' '=%.8f\n\n'],out.FunctionValue(length(out.FunctionValue)));
% %     
% %     % رļ
% %     fclose( fid );
% end