clear all;
close all;
clc;

% compilation for mex files
if exist( 'imboxfilter_c', 'file' ) == 0 || exist( 'imeig_power_c', 'file' ) == 0
	Makefile
end

%
% file names
%
fname = '119082.jpg';

% additional noise
nSig = 30;

%
% -------------------------------------------------------------------------
%

%
% Load an image
%
I0 = im2double( imread( fname ) );
[sy, sx, ncolor] = size( I0 );

%
% Additional noise
%
N = nSig/256 * randn( size(I0) );
I = I0 + N;

%
% -------------------------------------------------------------------------
%

%
% Our method
%

%
% parameters
%
param = SetParameter(nSig);



J = imclsmooth( I, param );




figure(4), imshow( [I, J] );
title('(left) noisy image, (right) our method');









