clear;
clc;

load('DataCube.mat','DataCube');

ts=tic;

min_val=min(min(min(DataCube)));
max_val=max(max(max(DataCube)));
DataCube=(DataCube-min_val)/(max_val-min_val);

sigma=est_noise(DataCube);


%%%%%%%%%%%%%%%%%%%%%  parameter setting  %%%%%%%%%%%%%%%%%%%%%%%%

% patch size
patch_size=[7,7];

% offset of overlapping patch sampling (the offset between two neighboring patches)
overlap_pixel=2;

% dictionary size
r=round(2.0*prod(patch_size));

% regularization parameter
lambda=sigma*sqrt(2*log(r));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[DataCubeOut,A,S]=nmf_denoising(DataCube,patch_size,overlap_pixel,r,lambda);

DataCubeOut=max(DataCubeOut,0);
DataCubeOut=min(DataCubeOut,1);

DataCubeOut=DataCubeOut*(max_val-min_val)+min_val;

t_total=toc(ts);

save('DataCubeOut_MTSNMF.mat','DataCubeOut','A','S','sigma','t_total');





