function [DataCubeOut, A, S] = nmf_denoising(DataCube, patch_size, overlap_pixel, r, lambda)

opts.maxit = 1000;
opts.tol = 1e-3;
opts.verbose = true;

[m, n, p] = size(DataCube);
patches = cell(p, 1);

for k = 1:p
    patches{k}=im2colstep(DataCube(:, :, k),patch_size,[overlap_pixel,overlap_pixel]);
end

[A, S] = MTSNMF(patches, r, lambda, opts);

DataCubeOut = zeros(m, n, p);

countImg= countcover([m,n],patch_size,[overlap_pixel,overlap_pixel]);

parfor k = 1:p
    DataCubeOut(:, :, k)= col2imstep(A{k}*S, [m, n], patch_size, [overlap_pixel, overlap_pixel])./countImg;
end

end

