%**************************************************************************
%Written by Antony Lam (antony@nii.ac.jp)
%National Institute of Informatics, Tokyo, Japan
%September 28, 2013

%Copyright (c) 2013 National Institute of Informatics

%This software is released under the terms of the GNU General Public
%License version 3 as published by the Free Software Foundation.
%A copy of the license is included with this software in the file gpl.txt
%and it may also be obtained at http://www.gnu.org/licenses/.

%The software is provided as is without any warranty or guaranteed support
%whatsoever. The National Institute of Informatics cannot be held
%responsible for its use, misuse, or functionality.

%If you find this code useful for your research, please cite our paper:
%Antony Lam, Imari Sato, and Yoichi Sato. "Denoising Hyperspectral Images
%Using Spectral Domain Statistics." In IEEE International Conference on
%Pattern Recognition (ICPR), IEEE, 2012.
%**************************************************************************

%This function performs bilateral denoising over each image in an image
%stack.
function imgs=bfilterStack(imgs,sigmas)
if nargin<2
    sigmas = ones(size(imgs,1),2);
    sigmas(:,2) = 0.05;
end
h = size(imgs,2);
w = size(imgs,3);
%I found this to be the best way to set k.
k = max(imgs(:)) - min(imgs(:));
for i = 1:size(imgs,1)
    temp = reshape(imgs(i,:,:),h,w);
    temp = k*bilateral(temp/k,3,sigmas(i,1),sigmas(i,2));
    imgs(i,:,:) = reshape(temp,[1 h w]);
end