%**************************************************************************
%Written by Antony Lam (antony@nii.ac.jp)
%National Institute of Informatics, Tokyo, Japan
%September 28, 2013

%Copyright (c) 2013 National Institute of Informatics

%This software is released under the terms of the GNU General Public
%License version 3 as published by the Free Software Foundation.
%A copy of the license is included with this software in the file gpl.txt
%and it may also be obtained at http://www.gnu.org/licenses/.

%The software is provided as is without any warranty or guaranteed support
%whatsoever. The National Institute of Informatics cannot be held
%responsible for its use, misuse, or functionality.

%If you find this code useful for your research, please cite our paper:
%Antony Lam, Imari Sato, and Yoichi Sato. "Denoising Hyperspectral Images
%Using Spectral Domain Statistics." In IEEE International Conference on
%Pattern Recognition (ICPR), IEEE, 2012.
%**************************************************************************

disp('Testing denoising of CDREF31_06couscous...');
load
[SNRdenoised,SNRnoisy,noisyImg,denoisedImg] = testDenoise(CDREF31_06couscous);
noisyImgBand = get2DNarrowbandImage(noisyImg,10)';
denoisedImgBand = get2DNarrowbandImage(denoisedImg,10)';
CDREF31_06couscousBand = get2DNarrowbandImage(CDREF31_06couscous,10)';

%Displaying Denoising Results
%Position the plot window and set its size.
set(0,'units','pixels');
Pix_SS = get(0,'screensize');
hFig = figure(1);
width = Pix_SS(end-1) - 0.1*Pix_SS(end-1);
height = Pix_SS(end-1)/3;
x = (Pix_SS(end-1) - width)/2;
y = Pix_SS(end) - 1.5*height;
set(hFig, 'Position', [x y width height]);

%Display the subplots.
colormap(gray(256));
subplot(1,3,1);
image(256*CDREF31_06couscousBand/max(CDREF31_06couscousBand(:)));
title('Original Clean Image (490 nm)');
axis off;

subplot(1,3,2);
image(256*noisyImgBand/max(noisyImgBand(:)));
title('Noisy (490 nm)');
axis off;

subplot(1,3,3);
image(256*denoisedImgBand/max(denoisedImgBand(:)));
title('Denoised (490 nm)');
axis off;

%Clean Up
clear Pix_SS hFig width height x y CDREF31_06couscousBand denoisedImgBand noisyImgBand