%**************************************************************************
%Written by Antony Lam (antony@nii.ac.jp)
%National Institute of Informatics, Tokyo, Japan
%September 28, 2013

%Copyright (c) 2013 National Institute of Informatics

%This software is released under the terms of the GNU General Public
%License version 3 as published by the Free Software Foundation.
%A copy of the license is included with this software in the file gpl.txt
%and it may also be obtained at http://www.gnu.org/licenses/.

%The software is provided as is without any warranty or guaranteed support
%whatsoever. The National Institute of Informatics cannot be held
%responsible for its use, misuse, or functionality.

%If you find this code useful for your research, please cite our paper:
%Antony Lam, Imari Sato, and Yoichi Sato. "Denoising Hyperspectral Images
%Using Spectral Domain Statistics." In IEEE International Conference on
%Pattern Recognition (ICPR), IEEE, 2012.
%**************************************************************************

%Get a narrowband image from a spectral image.
%img is the stack of spectral images.
%bandNumber is the particular narrowband to get. E.g. 1.
%If displayImg is true, the narroband image will also be displayed in a
%figure.
function img=get2DNarrowbandImage(img,bandNumber,displayImg)
img = reshape(img(bandNumber,:,:),size(img,2),size(img,3));
if nargin>2 && displayImg
    figure
    colormap(gray(256))
    %In case values slightly lower than zero occur.
    img(img<0) = 0;
    image(256*img/max(img(:)))
end