%**************************************************************************
%Written by Antony Lam (antony@nii.ac.jp)
%National Institute of Informatics, Tokyo, Japan
%September 28, 2013

%Copyright (c) 2013 National Institute of Informatics

%This software is released under the terms of the GNU General Public
%License version 3 as published by the Free Software Foundation.
%A copy of the license is included with this software in the file gpl.txt
%and it may also be obtained at http://www.gnu.org/licenses/.

%The software is provided as is without any warranty or guaranteed support
%whatsoever. The National Institute of Informatics cannot be held
%responsible for its use, misuse, or functionality.

%If you find this code useful for your research, please cite our paper:
%Antony Lam, Imari Sato, and Yoichi Sato. "Denoising Hyperspectral Images
%Using Spectral Domain Statistics." In IEEE International Conference on
%Pattern Recognition (ICPR), IEEE, 2012.
%**************************************************************************

%Convert an image stack into a column matrix. So that each column
%corresponds to an image.
function [imgs,mask]=imgs2ColMatrix(imgs,useMask)
if useMask
    mask = createMask(imgs);
else
    mask = true(size(imgs,2),size(imgs,3));
end
%dims = size(imgs);
%Convert to column vectors.
imgs = reshape(imgs(:),size(imgs,1),size(imgs,2)*size(imgs,3));
%Wipe out non-eye pixels.
imgs(:,~mask(:)) = [];
%validation = reshape(imgs(:),dims);