% simulate random projection
% c=0 denotes preserved pixels
function im_r=Interpolation_OLRT(im_n,c)


% Delaunay triangulation based interpolation
% [x,y,z]=find(c==0);

if size(im_n,3)==1
    [x,y]=find(c==0);
    [M,N]=size(im_n);
    [x1,y1]=meshgrid(1:M,1:N);
    im_r=griddata(x,y,im_n(find(c==0)),x1,y1);
    im_r=im_r';
    I=find(isnan(im_r)==0);
    I=find(isnan(im_r)==1);
    %J1=max(1,I-1);J2=min(M*N,I+1);
    im_r(I)=128;
else
    [x,y,z] = ind2sub(size(c),find(c==0));
    [M,N,B]=size(im_n);
    [x1,y1,z1]=meshgrid(1:M,1:N,1:B);
    im_r=griddata(x,y,z,im_n(c==0),x1,y1,z1);
    for i =1:B
        im_r(:,:,i) = im_r(:,:,i)';
    end
    I=find(isnan(im_r)==0);
    I=find(isnan(im_r)==1);
    %J1=max(1,I-1);J2=min(M*N,I+1);
    im_r(I)=128;
end